global { on_horse = false };
darkroom_enter = function(s)
	s:light(live(lamp) and (have(lamp) or where(lamp) == s))
end;
darkroom_left = function(s)
	if have(lamp) then
		s:light(false)
	end
end;

horse = obj {
	nam = _'конь';
	dsc = function(s)
		if not on_horse then
			p [[Вы также видите запряженного коня.]];
		end
	end;
	Exam = [[Вороной, богатырский конь. Он домчит вас куда угодно.]];
	life = function(s)
		if player_moved() then
			move(s, here(), where(s))
		end
	end;
	Walk = function(s)
		if on_horse then
			p [[Ну, вы и так на нем сидите.]]
			return
		end
		lifeon(s)
		on_horse = true
		p [[О.К.]]
	end;
	Down = function(s)
		if not on_horse then
			p [[Поищите лучше коня, сядте на него, а потом уже слезайте!]]
			return
		end
		p [[О.К.]]
		if here() ~= dvor then
			p [[Но он тут же ускакал.]];
		end
		lifeoff(s)
		on_horse = false
		move(s, dvor, here())
	end;
}

dvor = room {
	nam = 'Постоялый двор';
	dsc = [[Вы находитесь на постоялом дворе вашего батюшки-царя. 
		Далеко на севере простирается поле, а на земле открыт вход в погреб.]];
	d_to = 'pogreb';
	n_to = 'field';
}

chest = obj {
	nam = _'сундук';
	attr [[openable, ~opened, ~broken, container]];
	Attack = function(s, w)
		if s.broken then
			p [[Он ведь уже взломан?!]]
			return
		end
		if w == lom then
			s.broken = true
			pn [[O.K.]]
			p [[Он теперь не заперт.]]
			return
		end
		p [[Сундук не удалось сломать.]]
	end;
	before_Open = function(s, w)
		if s.broken then
			return
		end
		if w == lom then
			s.broken = true
			s.opened = true
			p [[Вы взломали сундук и открыли его!]]
			return
		end
		p [[Не получается. Он заперт, и ключ сломан в замке.]];
	end;
	Exam = function(s)
		p [[Видно, его давно уже не открывали.]]
		if s.broken then
			if s.opened then
				p [[Но сейчас он уже взломан и открыт.]]
				local r, n = parser:content(s)
				if n > 0 then
					p ("Внутри сундука есть: ", r)
				end
			else
				p [[Но сейчас он уже взломан.]]
			end
		end
	end;
	Search = function(s)
		if s.opened then
			if disabled(money) then
				p [[Вы нашли в сундуке кошелек.]]
				money:enable();
				put(money, s)
			end
		else
			p [[Сундук закрыт.]]
		end
	end;
	alias [[Search: LookAt]];
	obj = { };
};
money = obj {
	desc = 'кошелек с деньгами';
	nam = _'кошелек|~деньги';
	Exam = [[Кошелек полон серебряных денег.^P.S. Они не фальшивые.]];
	attr [[ takeable, dropable]];
}:disable();

lamp = obj {
	nam = _'лампа';
	attr [[takeable, dropable]];
	var { fuel = 100 };
	life = function(s)
		if player_moved() then
			s.fuel = s.fuel - 5
		end
		if s.fuel <= 0 then
			s.fuel = 0
			if here() == where(s) or have(s) then
				p [[Керосин кончился.]]
			end
			lifeoff(s)
			if here().light and have(s) then
				here():light(false)
			elseif not have(s) and where(s).light then
				where(s):light(false)
			end
		end
	end;
	LightOn = function(s)
		if s.fuel == 0 then
			p [[Керосин кончился.]]
			return
		end
		if here() == dark then
			p [[Вот теперь стало видно!]]
			dark:light(true)
		else
			pn "О.К."
			p [[Но здесь и так светло!]]
			if here().light then
				here():light(true)
			end
		end
		lifeon(s)
	end;
	LightOff = function(s)
		if not live(s) then
			p [[Она и не горела.]]
			return
		end
		pn "О.К."
		p "Лампа погасла."
		lifeoff(s)
		if here().light then
			here():light(false)
		end
	end;
	Exam = function(s)
		p [[Обычная керосинка.]]
		if live(s) then p [[Горит.]] end
		p ([[Керосин израсходован на ]], 100 - s.fuel, [[%]])
	end;
}

pogreb = room {
	nam = 'Погреб';
	attr [[ ~digged ]];
	enter = function(s)
		if on_horse then
			p [[Вы же на лошади!]]
			return false
		end
	end;
	dsc = [[Вы очутились в погребе, пропитанном запахом керосина. В углу 
		лежит старый сундук. Направо -- темное углубление. Кстати, 
		пол здесь не выстлан ничем.]];
	u_to = 'dvor';
	e_to = 'droom';
	d_to = function(s)
		if disabled(hole) then
			p [[Каким же образом? Вы ведь не крот!]];
			return
		end
		walk 'pogrebs'
	end;
	Dig = function(s)
		if not s.digged then
			hole:enable()
			p "Яма выкопана, но дна не видно.";
			s.digged = true
			return
		end
		p "Да полно вам копать, уже и так яма глубоко вырыта.";
	end;
	obj = { 'chest', 'hole' };
}

put(lamp, pogreb)
put(horse, dvor)

lopata = obj {
	desc = 'старая лопата';
	nam = _'лопата|~старая лопата';
	attr [[takeable, dropable]];
	Exam = [[Вы что, лопаты никогда не видели?]];
}

dark.nam = 'Темнота';
before_Default = [[Здесь не обойтись без света.]];
dark.dsc = [[Здесь архи-темно!]];
dark.before_LightOn = function(s)
end

droom = darkroom {
	enter = darkroom_enter;
	left = darkroom_left;
	nam = 'Кладовая';
	dsc = [[При свете лампы вы разглядели, что это -- кладовая.]];
	w_to = 'pogreb';
	obj = {'lopata'};
}

hole = obj {
	nam = _'яма';
	Exam = 'Не бойтесь, спускайтесь вниз. Не расшибетесь.';
	attr [[ door ]];
	door_to = 'pogrebs';
}:disable();

lom = obj {
	attr [[takeable, dropable]];
	desc = 'металлический лом';
	nam = _'лом|~металлический лом';
	Exam = "Выглядет как прочная металлическая палка.";
}

pogrebs = darkroom {
	enter = darkroom_enter;
	left = darkroom_left;
	dsc = [[Хорошо, что прихватили с собой лампу, а то ничего не разглядели бы в этом секретном подвале.]];
	nam = 'Секретный подвал';
	u_to = 'pogreb';
	obj = { 'lom' };
}
field = room {
	nam = 'Поле';
	dsc = [[Обыкновенное поле. Недавно вспахано. Тянется далеко на север.]];
	s_to = 'dvor';
	n_to = 'step';
	exit = function(s, t)
		if t == step and not on_horse then
			p [[Это очень далеко. Пешком вам туда не добраться.]]
			return false
		end
	end
}
step = room {
	nam = 'Степь';
	n_to = 'crossroad';
	s_to = 'field';
	dsc = [[Огромное пространство с юга на север занимает степь. Нет ни души.]];
}
crossroad = room {
	nam = 'У камня';
	n_to = 'usadba';
	s_to = 'step';
	e_to = 'bazar';
	w_to = 'road';
	enter = function(s, t)
		make_snapshot()
	end;
	dsc = [[Вот вы и у развилки. Перед вами 3 дороги и еще какой-то загадочный камень.]];
	obj = { 'stone' };
}

girl = obj {
	live = true;
	nam = _'девица|~красна-девица';
	morph = { ['красна'] = { 'красна', 'красну', 'красной', 'красну', 'красной', 'красной' } };
	Default = function(s)
		walk 'marry'
	end;
}

usadba = room {
	nam = 'Усадьба';
	s_to = 'crossroad';
	dsc = [[Вы оказались в усадьбе богатого купца. Навстречу вам выбегает красна-девица.]];
	obj = { 'girl' };
}

marry = cutscene {
	nam = 'Конец';
	nolife = true;
	dsc = [[Она берет вас за руки и ведет в дом, а впоследствии и под венец.. 
		Тут для вас и сказочке конец. (По-видимому вам не нужна Василиса прекрасная.)]];
	walk_to = 'badend';
}

badend = room {
	nolife = true;
	nam = 'Конец';
	dsc = [[К сожалению, игра здесь заканчивается, по не зависящим от создателя оной причинам.
		Советую попробовать снова, т.к. на ошибках учатся!]];
	Restart = function(s)
		restore_snapshot()
	end;
	verbs = { {"Restart", "переиграть"} };
}

stone = obj {
	nam = _'камень';
	Exam = [[На камне написано:^
"Направо пойдешь -- коня потеряешь,^
Прямо пойдешь -- женатому быть,^
Налево пойдешь -- себя потеряешь."]];
	Take = [[Тяжеленный!]];
	alias [[Take: Push, Pull ]];
	Attack = [[Слишком самонадеянно с вашей стороны.]];
}

bab1 = obj {
	nam = _'старушка|~старуха';
	dsc = [[К вам подходит дряхленькая старушка и просит: "Подай на пропитание, милок!"]];
	Exam = [[Выглядит как нищая, одета в грязные лохмотья.]];
	Attack = [[Бабушке это не понравится.]];
	Receive = function(s, w)
		if w == money then
			remove(w, me())
			p [[Бабушка вас очень благодарит и дает вам какую-то грамоту. И затем исчезает...]]
			take 'paper'
			remove(s)
		end
	end;
	TalkTo = [["Подай на пропитание, милок!"]];
}

paper = obj {
	attr [[dropable,takeable]];
	nam = _'грамота';
	Exam = 'Грамота гласит:^"Не ешь этого человека.^С уважением, твоя сестра."';
}

bazar = room {
	nam = 'Базар';
	dsc = [[На этом небольшом базаре вы видите большое разнообразие товаров.]];
	obj = { 'bab1' };
	w_to = 'crossroad';
	e_to = 'forest';
}

forest = room {
	nam = 'Лес';
	dsc = [[Лес, в котором вы находитесь, выглядет как-то страшновато, и у вас забегали мурашки по коже.]];
	w_to = 'bazar';
	s_to = 'izba';
	n_to = 'forest2';
}

bab2 = obj {
	live = true;
	attr [[attack]];
	nam = _'Баба-Яга|~старуха|~Яга';
	morph = { ["Яга"] = {"Яга", "Ягу", "Яге", "Ягу", "Ягой", "Яге"}};
	Exam = function(s)
		p [[Похожа на свою сестру. У нее остался один-единственный зуб.]];
		if s.attack then
			p [[Ой, она намеривается вас съесть!]];
			walk 'yaga'
		end
	end;
	Default = function(s)
		p [[С Бабой-Ягой шутки плохи!]]
		if s.attack then
			walk 'yaga'
		end
	end;
	Receive = function(s, w)
		if w == paper then
			s.attack = false
			p [[Она прочла и дала вам меч-кладенец.]];
			remove(w, me())
			take(sword)
			if on_horse then
				p "Она также забрала у вас коня, так как он вам уже не нужен.";
				on_horse = false
				lifeoff(horse)
				remove(horse)
			else
				p [["А где мой конь, я тебя спрашиваю?"-- заорала баба-яга и двинулась...]]
				walk 'yaga'
			end

		end
	end;
	dsc = function(s)
		if s.attack then
			p [[ Баба-Яга подкрадывается к вам.]];
		end
	end;
	Kill = function(s, w)
		if w == sword then
			p [[На нее меч не поднимается.]];
			return
		else
			p [[Бабушка вам этого не простит.]]
			walk 'yaga'
			return
		end
	end;
}

yaga = cutscene {
	nam = 'Конец';
	nolife = true;
	dsc = [[Не успели вы и ахнуть, как Баба-Яга вас съела.]];
	walk_to = 'badend';
}

izba = room {
	nam = 'Избушка';
	dsc = [[Вы зашли в избушку на курьих ножках. Баба-Яга недовольно ворчит: "Тьфу,человечьим духом запахло."]];
	n_to = 'forest';
	obj = { 'bab2' };
}

sword = room {
	attr [[takeable, dropable]];
	desc = 'меч-кладенец';
	nam = _'меч';
	Exam = "Это очень прочное, надежное и смертоносное оружие.";
}

snake = obj {
	live = true;
	nam = _'змея';
	dsc = [[Осторожно, здесь ядовитая змея, которая не дает вам идти прямо.]];
	Kill = function(s, w)
		p "Ее труп бесследно исчез, но кое-что осталось сверкать на ее месте.";
		remove(s)
		put(ring)
	end;
	Default = function(s)
		walk 'snakeend'
	end;
	Exam = function(s)
		p [[Очень ядовита, очень. Сейчас она вас ужалит!!]];
		walk 'snakeend'
	end;
	Attack = function(s)
		walk 'snakeend'
		return true
	end
}

snakeend = cutscene {
	nam = 'Конец';
	nolife = true;
	dsc = [[Ну вот, доигрались, змея вас укусила.]];
	walk_to = 'badend';
}

forest2 = room {
	nam = 'Чаща';
	dsc = [[Вы находитесь в глубокой чаще леса. Тут жутковато.]];
	s_to = 'forest';
	n_to = 'crossroad';
	exit = function(s, t)
		if t == crossroad and seen(snake) then
			walk 'snakeend'
		end
	end;
	obj = { 'snake' };
}

ring = obj {
	attr [[takeable, dropable]];
	desc = 'золотой перстень';
	nam = _'перстень|~золотой перстень';
	Exam = "Очень драгоценный, карат 40. Он прямо-таки сверкает.";
}

road = room {
	nam = 'Дорога';
	e_to = 'crossroad';
	w_to = 'firefield';
	dsc = [[Вы идете по узкой пыльной дороге. слева виднеется поляна.]];
}

zmey = obj {
	live = true;
	attr [[alive]];
	nam = _'Змей-Горыныч|~змей|~Горыныч';
	morph = { ["Горыныч"] = {"Горыныч", "Горыныча", "Горынычу", "Горыныча", "Горынычем", "Горыныче"}};
	dsc = function(s)
		if s.alive then
			p [[Огнедышащий Змей-Горыныч закрывает путь на запад.]];
		end
	end;
	Exam = function(s)
		if not s.alive then
			return "Но ведь вы его уже убили!"
		end
		p "Огромный,ужасающий змей. вам конец!"
		walk 'zmeyend'
	end;
	Default = function(s)
		if not s.alive then
			return "Но ведь вы его уже убили!"
		end
		p [[С Горынычем шутки плохи!]]
		walk 'zmeyend'
	end;
	Kill = function(s, w)
		if not s.alive then
			return "Но ведь вы его уже убили!"
		end
		p [[Все три головы упали на землю и пропали... Теперь путь открыт!]];
		s.alive = false
	end;
}

zmeyend = cutscene {
	nam = 'Конец';
	nolife = true;
	dsc = [[Змей-Горыныч не вытерпел и испепелил вас!]];
	walk_to = 'badend';
}

firefield = room {
	nam = 'Поляна';
	e_to = 'road';
	w_to = 'temnica';
	s_to = 'tropa';
	dsc = [[Эта поляна сильно выжжена пламенем. На западе -- какое-то строение. На востоке и на юге -- дорога.]];
	obj = { 'zmey' };
	exit = function(s, t)
		if t == temnica and zmey.alive then
			walk 'zmeyend'
		end
	end;
}

key = obj {
	nam = _'ключ|~ржавый ключ';
	desc = 'ржавый ключ';
	attr [[takeable, dropable]];
}

vasilisa = obj {
	nam = _'Василиса-прекрасная|~Василиса';
	attr [[alive]];
	morph = { ['прекрасная'] = { 'Прекрасная', 'Прекрасную', 'Прекрасной', 'Прекрасную', 'Прекрасной', 'Прекрасной' } };
	live = true;
	Exam = [[Неужели вы не понимаете, что ее красоту ни в сказке сказать, ни пером описать,тем более в игре!!]];
	Attack = "Вы явно маньяк!";
	Kill = function(s, w)
		p "Вы явно маньяк! Ваша невеста погибла от вашей же руки.";
		walk 'badend'
	end;
	TalkTo = [[..Он отобрал у меня корону и заточил в эту мерзкую темницу...]];
	Receive = function(s, w)
		if w == korona then
			if kash.alive then
				p "Василиса говорит:^";
				p [["Сперва убей Кощея, а то он снова отнимет у меня корону."]]
			else
				walk 'happyend'
			end
		end
	end
}

temnica = room {
	nam = 'Темница';
	dsc = function(s)
		p [[Этим строением оказалась темница, где томится Василиса Прекрасная. 
			Она говорит: "Иванушка, где же ты был до сих пор? А то
			меня Кощей уже совсем замучил. Захотел на мне женитьса... 
			Я конечно отказала ему и он отобрал у меня корону и заточил в
			эту мерзкую темницу..."]];
		if seen 'key' then
			p [[^"Но я у него украла этот ключ. Может,тебе он пригодится?"]];
		end
	end;
	e_to = 'firefield';
	obj = { 'vasilisa', 'key' };
}

rope = obj {
	nam = _'веревка';
	desc = function(s)
		if well.tie and here() == plosh then
			pr 'привязанная веревка'
		else
			pr 'длинная веревка';
		end
	end;
	attr [[takeable, dropable]];
	before_Take = function(s)
		well.tie = false
	end;
	Exam = function(s)
		if well.tie then
			p "Веревка привязана к колодцу и ее конец скрывается в глубине."
			return
		end
		p [[Достаточно прочная и длинная. Может выдержать даже человека.]];
	end;
	Tie = function(s, w)
		if w == well then
			p [[Вы привязали ее к колодцу и спустили вниз.]];
			w.tie = true
			drop(s)
		end
	end
}

gnome = obj {
	nam = _'гном';
	attr [[ alive ]];
	dsc = function(s)
		if s.alive then
			p [[Вдруг вы встретили гнома. Он озабоченно бормочет: "Куда ж я его задевал?"]];
		end
	end;

	before_Default = function(s, ev)
		if not s.alive then
			p [[Эх вы, богатырь называется... Мало того,что бедного гнома загубили ни за что, а теперь еще и издеваетесь. Маньяк, одно слово..]];
		end
	end;

	Exam = function(s)
		p [[Маленький такой, с седой бородой. Похоже, он что-то потерял.]];
	end;
	Kill = function(s)
		p [[О.К.^Но чем он вам не понравился?]];
		s.alive = false;
	end;
	Receive = function(s, w)
		if w == ring then
			p [["Вот то, что я искал, спасибо! На, может, пригодится." -- сказал гном.]];
			remove(w, me())
			remove(s)
			put 'rope'
		end
	end;
	TalkTo = function(s)
		p [[Он озабоченно бормочет: "Куда ж я его задевал?"]]
	end;
}

tropa = room {
	nam = 'Тропинка';
	dsc = [[Вы пошли по тропинке, которая ведет на юг.]];
	n_to = 'firefield';
	s_to = 'plosh';
	obj = {'gnome'};
}

well = obj {
	nam = _'колодец';
	attr [[ ~tie ]];
	Exam = function(s)
		p "Похоже, он сухой и очень глубокий."
		if s.tie then
			p "К колодцу привязана веревка.";
		else
			p "..И если туда свалиться...";
		end
	end;
}

plosh = room {
	nam = 'У колодца';
	enter = function(s)
		make_snapshot()
	end;
	n_to = 'tropa';
	d_to = 'inwell';
	w_to = 'castle';
	dsc = [[Вы вышли на небольшую площадку посреди которой стоит колодец. Налево виднеется замок.]];
	obj = { 'well' };
}

inwell = room {
	nam = 'В колодце';
	dsc = [[Вы очутились на дне колодца. Пола в сумерках не видно...]];
	enter = function(s, f)
		if f == plosh and not well.tie then
			p (s.dsc)
			p [[Но вы разбились, так как упали с огромной высоты. Вы погибли.]]
			walk 'badend'
		end
	end;
	u_to = 'plosh';
	d_to = 'inwell2';
}

larec = obj {
	nam = _'ларец';
	attr [[takeable, dropable, openable]];
	Exam = [[Из чего сделан не ясно, но точно из чего-то архипрочного.]];
	before_Open = function(s, w)
		if w == key then
			return "Тут нет замочной скважины.";
		end
		if w == palica then
			parser:redirect { "Attack", s, w }
			return
		end
		p [[Не хочет открываться!]];
	end;
	Attack = function(s, w)
		if w == palica then
			p [[O.K.^Ларец раскололся. И из него выпало яйцо.]]
			remove(s)
			remove(s, me())
			put 'oskol'
			put 'egg'
			return
		end
		p [[Не получается: не за что зацепить.]];
	end;
}

inwell2 = darkroom {
	enter = darkroom_enter;
	left = darkroom_left;
	nam = 'На дне колодца';
	dsc = [[Вот вы и на самом дне колодца. Ух, здесь очень сыро!]];
	u_to = 'inwell';
	obj = { 'larec' };
}

wdoor = obj {
	nam = _'дверь';
	attr [[ openable, door, locked ]];
	before_Open = function(s, w)
		if not s.locked then
			return
		end
		if w == key then
			p [[О.К.]]
			s.locked = false
			s.opened = true
			return
		else
			if w then
				p [[Не получается.]]
			else
				p [[Дверь заперта.]]
			end
			return
		end
	end;
	before_Close = function(s, w)
		if not w then
			return
		end
--		s.opened = false
		if w == key then
			s.locked = true
		else
			p [[Может, сделать это проще?]]
		end
	end;

	when_open = [[Здесь не заперто.]];
	Attack = function(s)
		p [[Не поддается.]];
	end;
	when_closed = [[Дверь заперта.]];
	Exam = function(s)
		p [[Дверь довольно прочная]];
		if s.opened then
			p [[и сейчас открыта.]]
		else
			if not s.locked then
				p [[и сейчас закрыта, но не заперта.]]
			else
				p [[и сейчас закрыта и заперта на ключ.]]
			end

		end
	end;
	door_to = function(s)
		if here() == castle then
			return 'pods';
		else
			return 'castle';
		end
	end;
}

castle = room {
	nam = 'Замок';
	dsc = [[Вы сейчас у входа в замок. Подъемный мост как будто бы  специально для вас опущен.    
		На севере имеется дверь.]];
	e_to = 'plosh';
	n_to = 'pods';
	s_to = 'castle2';
	exit = function(s, to)
		if to == pods and not wdoor.opened then
			p [[Дверь заперта.]]
			return false
		end
	end;
	obj = { 'wdoor' };
}

palica = obj {
	desc = 'увесистая палица';
	nam = _'палица|~увесистая палица';
	attr [[takeable, dropable]];
	Exam = [[Такой палицей что угодно разбить можно!]];
}

pods = room {
	nam = 'Подсобка';
	dsc = [[Вы в заброшенной подсобке. Похоже, здесь хранили оружие. 
		На юге есть дверь -- это выход.]];
	obj = { 'wdoor', 'palica' };
	s_to = 'castle';
	exit = function(s, to)
		if to == castle and not wdoor.opened then
			p [[Дверь заперта.]]
			return false
		end
	end;
}
oskol = obj {
	desc = 'осколки от ларца';
	nam = _'осколки';
	attr [[takeable, dropable ]];
	Exam = [[Изучив осколки вы поняли, что зря корчили из себя 
		Шерлока Холмса.]];
}

egg = obj {
	desc = 'черное яйцо';
	nam = _'яйцо|~черное яйцо';
	attr [[dropable, takeable ]];
	Attack = [[Яйцо еще может пригодиться.]];
	after_Drop = [[Ничего не происходит. Яйцо покатилось по полу.]];
	Exam = [[После долгих, упорных и нудных экспертиз удалось установить, 
		что оно не куриное и вообще не птичье.]];
	Give = function(s, w)
		if w == kash then
			remove(s, me())
			p [[O.K. Но вы вы даете ему его собственную смерть!]];
		end
	end;
	Drop = function(s, w)
		if w == kash then
			parser:redirect { 'Attack', w, s };
		end
	end;
}

luk = obj {
	nam = _'люк|~железный люк';
	attr [[ openable, door, locked ]];
	Push = [[Он очень тяжелый, вам его не поднять.]];
	alias [[Push: Take, Pull, Close ]];
	when_closed = [[Люк закрыт.]];
	Exam = function(s)
		pr [[Люк сделан из твердого железа]]
		if s.locked then
			p " и очень хорошо забит в пол"
		else
			p ", он открыт и валяется неподалеку.";
		end
	end;
	Open = function(s, w)
		if s.locked then
			if w == lom then
				parser:redirect { 'Attack', s, w }
				return
			end
			p [[Не выходит: сильно вбит в пол.]];
			return
		end
	end;
	Attack = function(s, w)
		if s.locked then
			if w == lom then
				s.locked = false
				p [[O.K.^Люк отлетает в сторону и открывается потайной ход!]]
				s.opened = true
				return
			else
				p [[Не поддается.]]
			end
		else
			p [[Он ведь уже взломан?]]
		end
	end;
	door_to = 'hiddenroom';
}
castle2 = darkroom {
	nam = 'Коридор';
	enter = darkroom_enter;
	left = darkroom_left;
	dsc = [[Это небольшой коридор замка. Внизу имеется люк. На юге 
		виден яркий свет.]];
	n_to = 'castle';
	d_to = 'hiddenroom';
	s_to = 'castlepath';
	exit = function(s, to)
		if to == hiddenroom and luk.locked then
			p [[Люк закрыт.]]
			return false
		end
	end;
	obj = { 'luk' };
}
korona = obj {
	nam = _'корона|~золотая корона';
	desc = [[золотая корона]];
	Exam = [[Обыкновенная золотая корона. Она увешана разными драгоценными камнями.]];
	attr [[takeable, dropable ]];
}
hiddenroom = darkroom {
	nam = 'Тайник';
	enter = darkroom_enter;
	left = darkroom_left;
	u_to = 'castle2';
	dsc = [[Вы попали в тайник Кощея. Он весь обложен камнями. 
		Вверху открыт люк.]];
	obj = { 'korona' };
}
castlepath = room {
	nam = 'Узкий проход';
	dsc = [[Вы идете по узкому проходу, залитому ярким светом. 
		Он ведет на юг.]];
	n_to = 'castle2';
	s_to = 'entrance';
}
wdoor2 = obj {
	attr [[door,openable]];
	nam = _'дверь';
	dsc = function(s)
		if s.opened then
			p [[На юге раньше была дверь... Но
				теперь путь открыт!]]
			return
		end
		p [[А на юге -- очень прочная дубовая дверь.]];
	end;
	Open = function(s)
		if s.opened then
			p [[Так она же вырвана!]];
			return
		end
		p [[Такое впечатление, будто она замурована.]]
		return
	end;
	Close = function(s)
		if s.opened then
			return s:Open()
		else
			p [[Дверь закрыта.]]
		end
	end;
	Exam = [[Дверь сделана из хорошего дуба. Кстати, на ней нацарапано:
		"Здесь был Миша 15.08.94"]];
	Attack = function(s, w)
		if s.opened then
			return s:Open()
		end
		p [[Все ваши попытки взломать дверь провалились.]]
	end;
	Explode = function(s)
		p [[Имейте в виду, что динамит вам еще понадобится!]]
	end;
	door_to = 'bedroom';
}

entrance = room {
	nam = 'Прихожая';
	dsc = function(s)
		p [[Очевидно, это прихожая.]]
		if udo.alive then
			p [[С востока доносится страшный рев.]];
		else
			p [[С востока доносится звон цепей.]]
		end
	end;
	obj = { 'wdoor2' };
	enter = function(s, t)
		make_snapshot()
	end;
	exit = function(s, to)
		if to == bedroom and not wdoor2.opened then
			p [[Дверь закрыта.]]
			return false
		end
	end;
	Help = function(s)
		if not wdoor2.opened then
			p "Вы позвали на помощь..."
			p "Вдруг явился Илья Муромец"
			p "и вышиб дверь."
			wdoor2.opened = true
		end
	end;
	n_to = 'castlepath';
	e_to = 'stoneroom';
	s_to = 'bedroom';
}

udo = obj {
	nam = _'Чудо-Юдо|~Юдо';
	live = true;
	attr [[alive]];
	morph = { ['Юдо'] = { 'Юдо', 'Юдо', 'Юду', 'Юдо', 'Юдом', 'Юде' } };
	dsc = function(s)
		if s.alive then
			p [[Здесь также сидит, оглушая вас своим ревом, Чудо-Юдо.]];
		end;
	end;
	Exam = function(s)
		if not s.alive then
			return "Но ведь вы его уже убили!"
		end
		p [[Да он вас убьет сейчас, а вы его разглядываете!]];
		walk 'udoend'
	end;
	Default = function(s, ev)
		if not s.alive then
			return "Но ведь вы его уже убили!"
		end
		p [[С Чудом-Юдом шутки плохи!]]
		walk 'udoend'
	end;
	Kill = function(s, w)
		if not s.alive then
			return "Но ведь вы его уже убили!"
		end
		s.alive = false
		p "Оно испустило предсмертный крик и сдохло..."
	end;
}

stoneroom = room {
	nam = 'Каменная комната';
	dsc = [[Вы находитесь в прохладной каменной комнате, 
		опутанной цепями.]];
	obj = { 'udo', 'dynamit' };
	w_to = 'entrance';
}

dynamit = obj {
	nam = _'динамит';
	attr [[takeable, dropable]];
	desc = [[динамит из будущего]];
	Exam = [[Этот динамит заброшен сюда из 1994 года Бабой-Ягой.]];
	after_Take = function(s)
		if udo.alive then
			walk 'udoend'
		end
	end
}

udoend = cutscene {
	nam = 'Конец';
	nolife = true;
	dsc = [[Увы, ваши барабанные перепонки не выдержали этого ужасного 
		рева, и вы упали замертво.]];
	walk_to = 'badend';
}

bedroom = room {
	nam = 'Спальня';
	dsc = [[Это спальня, судя по кроватям. Но выглядит все так, 
		будто никто здесь отродясь не спал.
		Есть выходы на восток и север.]];
	n_to = 'entrance';
	e_to = 'hall';
}

wall = obj {
	nam = _'стена';
	Walk = [[Куда, ведь там стена!]];
	dsc = function(s)
		p 'На востоке -- голая стена...'
	end;
	Explode = function(s)
		replace(s, brokenwall)
		remove(dynamit, me())
		pn [[O.K.]]
		p [[Отличный взрывон!!!!! Стену вырвало и образовался проход.]]
	end;
	Attack = [[Стена устояла.]];
}

brokenwall = obj {
	nam = _'дыра|~стена';
	attr [[door]];
	door_to = 'lair';
	dsc = 'На востоке виднеется большая дыра. (Кто-то тут взрывал...)';
	Attack = [[Стена уже сломана.]];
}

hall = room {
	nam = 'Гостинная';
	dsc = [[Это гостинная, но выглядит очень заброшено... Выход -- запад.]];
	w_to = 'bedroom';
	e_to = 'lair';
	exit = function(s, to)
		if to == lair and not seen 'brokenwall' then
			p [[Куда, ведь там стена!]]
			return false
		end
	end;
	obj = { 'wall' };
}

kash = obj {
	nam = _'Кащей|~Кощей';
	attr [[ alive ]];
	morph = { ['Кащей'] = {"Кащей", "Кащея", "Кащею", "Кащея", "Кащеем", "Кащее"},
		['Кощей'] = {"Кощей", "Кощея", "Кощею", "Кощея", "Кощеем", "Кощее"}     };
	dsc = function(s)
		if s.alive then
			p [[Вдруг появляется Кащей и произносит какое-то заклинание...]];
		end
	end;
	Exam = function(s)
		if not s.alive then
			p [[Но ведь вы его уже убили!]]
		else
			p [[Худой, сухой такой старикашка с костлявыми пальцами бормочет какое-то заклинание.]];
		end
	end;
	live = true;
	after_Any = function(s, ev)
		if s.alive then
			walk 'kashend'
		end
	end;
	Attack = function(s, w)
		if w == egg then
			p [[Вы попали прямо в Кощееву морду! Яйцо разбилось и кощей умер.]]
			remove(w, me())
			s.alive = false
			return
		end
		if not s.alive then
			p [[Но ведь вы его уже убили!]]
			return
		end
		p [[Кащею это не понравилось.]]
	end;
	Kill = function(s, w)
		parser:redirect { 'Attack', s, w }
	end
}

lair = room {
	nam = 'Логово Кащея';
	w_to = 'hall';
	Smell = 'Фу! Воняет Кащеем.';
	dsc = [[Вы очутились в белокаменных покоях. Фу, здесь отвратительно 
		воняет Кащеем. выход на западе.]];
	obj = { 'kash' };
}

kashend = cutscene {
	nam = 'Конец';
	nolife = true;
	dsc = [[...И вы превращаетесь в червяка, которого Кащей 
		тут же раздавливает ногой. Примите мои соболезнования.]];
	walk_to = 'badend';
}

happyend = cutscene {
	nam = 'Конец';
	fading = 16;
	nolife = true;
	enter = function(s)
		set_music 'mus/class_fe.mod' 
	end;
	dsc = [[Василиса берет корону и говорит: "Спасибо, 
		суженый мой! А теперь нам пора домой!"^
		И вдруг появляется гном и переносит вас во дворец. 
		На следующий день вы сыграли свадьбу.^
		Вот и сказочке конец, а кто эту игру до конца дошел -- тому
		медаль!!!!!!!!!!!!!!!!!!!!!!!!]];
	walk_to = 'happyend2';
}

happyend2 = room {
	nam = 'Конец';
	noparser = true;
	fading = 16;
	nolife = true;
	gfx = 'gfx/ivan.png';
	dsc = function(s)
		pn (txtc[[ИГРА ОКОНЧЕНА]]);
		pn()
		p (txtc[[В игре использованы треки:^
		Fatigue by Zerosum^
		maktone/class.superstars.sac^for dreamhack01 oldskool music compo^^]]);
		pn [[Если вы честно прошли эту игру, примите мои самые искренние поздравления!]]
		p (txtr[[http://instead.syscall.ru, 2013]])
	end
}
