-- $Name: Иван Царевич$
-- $Version: 0.2$

instead_version "1.9.0"

require "snapshots"
require "nolife"
-- require "hideinv"
require "quotes"
require "para"
require "dash"
-- require "para"
require "sprites"

require "parser/metaparser"
input.cursor = img 'gfx/cursor.gif'

parser.notitle = true
set_music 'mus/fatigue.xm'

f1 = sprite.font('gfx/f1.ttf', 18)

game.pic = function(s)
	local s = stead.dispof(here())
	if s ~= old_title then
		old_title = s
		sprite.free(old_sprite)
		local sp = sprite.text(f1, old_title, 'black')
		old_sprite = sp
	end
	return old_sprite
end

morph.debug = true
parser.cmd_history = true
parser.empty_warning = '?'
parser.hintinv = true
morph.yo = false
morph:init ('main.lua', 'game.lua')

me().person = 2
me().plural = true
parser.compass = true

parser.directions = { 
	{"n_to", "на", "север" };
	{"e_to", "на", "восток"};
	{"s_to", "на", "юг"};
	{"w_to", "на", "запад"};
	{"d_to", "вниз"};
	{"u_to", "наверх"};
	{"u_to", "вверх"};
	{"r_to", "направо" };
	{"l_to", "налево" };
	{"f_to", "прямо" };
}

parser.err_filter = false
parser.noway = function() p [[Туда вам не пройти.]]; end
parser.unknown_verb = [[Я есть плохо понимать по-русски. Попробуйте другую фразу.]];
parser.unknown_obj = function(s, a, v)
	if v == "" then
		p ("Предложение не окончено.")
		return
	end
	p ("У вас галлюцинации.")
	return
end;

parser.footer = function(s)
	local k, v
	local rc = ''
	local o = {}
	for k, v in ipairs(objs()) do
		if v.takeable and not disabled(v) then
			stead.table.insert(o, v)
		end
	end
	if #o >= 1 then
		p "В поле вашего зрения: "
		for k, v in ipairs(o) do
			if not disabled(v) then
				if v.desc then
					local r = stead.call(v, 'desc')
					pr(r)
				else
					pr(v:M())
				end
				if k < #o then
					p ","
				else
					p "."
				end
			end
		end
	end
end
parser:init()

-- parser.scroll = false
parser.events.before_Walk = function(s, w)
	if w == 'направо' then
		parser:redirect {"Walk", "восток"};
	elseif w == 'налево' then
		parser:redirect {"Walk", "запад"};
	elseif w == 'прямо' then
		parser:redirect {"Walk", "север"};
	end
end

me().Exam = function(s, w)
	local rc, n = parser:content(me())
	p [[В вашем распоряжении: ]]
	if n == 0 then
		p [[нет совсем ничего.]]
	else
		p (rc)
	end
	if on_horse then
		p [[Вы на коне.]]
	end
end

parser.events.Inventory = me().Exam;

dofile 'game.lua'
hints = obj {
	nam = 'приглашение';
	life = function(s)
		if here().nolife then
			return
		end
		local v = { "Ваши действия?",
			"Что дальше?",
			"Жду Ваших указаний.",
			"Что Ваш аналитический ум вам подсказывает?",
			"С нетерпением жду Вашего следующего наимудрейшего хода."};
		return v[rnd(#v)]
	end;
}
main = cutscene {
	attr [[ ~intro ]];
	nam = 'Пролог';
	dsc = {[[Добро пожаловать в приключенческую игру "Иван Царевич",
		сделанную с использованием программы "A.B.S." (с) Инфорком.^^
		(с) 1995 Греков Михаил Леонидович, 'G&M', Краснодар.^^
		Ремейк выполнен Петром Косых на движке INSTEAD в 2013 г.]],
		[[Кащей бессмертный выкрал Василису Прекрасную и унес ее за  
		тридевять земель в свое царство. Ее жених, Иван Царевич (это вы) 
		отправился на поиски своей невесты. Его цель -- найти ее, убить Кащея и жениться на 
		Василисе.]],
		[[ Основные слова: помощь, осмотреть, взять, положить, инвентарь, 
			север, юг, запад, восток, вверх,
			вниз. А остальные глаголы и слова предстоит разведать вам самим.^
			Удачи вам!]],
		[[
		    P.S. полезные советы:^
		    1) Используйте <таб> или <пробел> для автодополнения;^
		    2) Почаще осматривайтесь;^
		    3) Почаще осматривайте предмет;^
		    4) Направо/налево/прямо это синонимы восток/запад/север.
		]]
		};
	walk_to = 'dvor';
	exit = function(s)
		lifeon(hints, 100)
	end;
}

parser.events.Down = function(s, w)
	p [[Сначала нужно на это залезть.]]
end

parser.events.LightOn = function(s)
	p [[Но у вас нет даже спичек!]]
end;

parser.events.LightOff = function(s)
	p [[Вас самого надо компостером погасить!]]
end;

parser.events.before_Dig = function(s, w)
	if not have 'lopata' or (w and w ~= lopata) then
		p "Для этого нужен подходящий инструмент...";
	end
end;
parser.events.after_Dig = function(s)
	if s:react() then
		return
	end 
	p [[Ничего не выкапывается.]]
end
parser.events.Give = [[Разве вам самому это не нужно?]];
parser.events.before_Kill = function(s, w, b)
	if b == egg and w == kash then
		return
	end
	if not w:G().live or (b and b ~= sword) then
		p "Послушайте, а вы случайно не маньяк?"
		return
	end
	if not have(sword) then
		p "У вас нет для этого подходящего оружия.";
		return
	end
end
parser.events.before_Help = function(s)
	if wdoor2.opened then
		p [[Помощь вам больше не понадобится.]]
	end
end

parser.events.Help = function(s)
	p [[Не время еще просить о помощи!]];
end

parser.events.before_Explode = function(self, w)
	if w == dynamit then
		p [[Что вы хотите взорвать динамитом?]]
		return
	end
	if w:G().live then
		p [[Да вы маньяк!]]
		return
	end
	if not have(dynamit) then
		p [[Вам нечем взрывать.]]
		if seen(dynamit) then p [[Возьмите динамит.]] end
		return
	end
end

parser.events.Explode = function(self, w)
	p [[Я бы на вашем месте не стал бы тратить динамит именно здесь.]]
end

parser.events.before_Attack = function(self, s, w)
	if w == dynamit then
		parser:redirect { "Explode", s }
		return
	end
	if w == sword then
		parser:redirect { 'Kill', s, w };
		return
	end
end

Verb { "Dig %3", "копать|~рыть", "{}|{inv}тв" }
Verb { "Walk %3", "сесть|~залезть", "на", "{obj}вн" }
Verb { "Down %3", "слезть", "с", "{obj}рд" }
Verb { "LightOn %2", "зажечь|~поджечь", "{obj}вн|{inv}вн" }
Verb { "LightOff %2", "потушить|~затушить|~загасить|~погасить", "{obj}вн|{inv}вн" }
Verb { "Attack %2 %3", "~взломать", "{obj}вн", "{}|{inv}тв"};
Verb { "Kill %2 %3", "убить", "{obj}вн", "{}|{inv}тв" };
Verb { "Help", "помощь|~помогите" };
Verb { "Explode %2", "взорвать|~подорвать|~разнести", "{obj}вн" }
